using C1.Win.TrueDBGrid.Excel;
using System.Data;

namespace WinFormsApp1;

public partial class Form1 : Form
{
   public Form1()
   {
      InitializeComponent();
   }
   DataTable dtAc = new DataTable("Ac");
   DataSet ds = new();

   private void Form1_Load(object sender, EventArgs e)
   {
      CreateAcTable();
      ds.Tables.Add(GetTrxTable());

      ddown1.Height = 100;
      ddown1.DataSource = dtAc;

      TDBGrid1.DataSource = ds.Tables[0];
      TDBGrid1.AllowAddNew = true;
      TDBGrid1.Splits[0].DisplayColumns["AcId"].Width = 200;
      TDBGrid1.Splits[0].DisplayColumns["Description"].Width = 300;
      TDBGrid1.Columns["AcId"].Caption = "Account Name";
      TDBGrid1.Splits[0].DisplayColumns["Seq"].Visible = false;
      SetGridDropDown(TDBGrid1, ddown1, "AcId", "Name");


      TDBGrid1.Columns["AcId"].DropDown = ddown1;
      TDBGrid1.Columns["AcId"].ValueItems.Translate = true;
      ddown1.DisplayColumns["AcId"].Visible = false;
      ddown1.ValueMember = "AcId";
      ddown1.DisplayMember = "Name";
      ddown1.DisplayColumns[1].Width = 300;
      ddown1.ValueTranslate = true;

   }
   private DataTable GetTrxTable()
   {
      DataTable dtTrx = new();
      dtTrx.Columns.Add("Seq", typeof(int));
      dtTrx.Columns.Add("AcId", typeof(int));
      dtTrx.Columns.Add("Amount", typeof(int));
      dtTrx.Columns.Add("Description", typeof(string));
      //Add some data
      dtTrx.Rows.Add(1, 1, 100, "Some Description");
      dtTrx.Rows.Add(2, 2, 200, "Some Description");
      return dtTrx;
   }

   private void CreateAcTable()
   {
      dtAc.Columns.Add("AcId", typeof(int));
      dtAc.Columns.Add("Name", typeof(string));

      dtAc.Rows.Add(1, "John Doe");
      dtAc.Rows.Add(2, "Jane Smith");
      dtAc.Rows.Add(3, "Michael Johnson");
   }

   private void btnExport_Click(object sender, EventArgs e)
   {
      TDBGrid1.SaveExcel(txtFileName.Text,null,null,false,false,true);
   }

   public void SetGridDropDown(C1.Win.TrueDBGrid.C1TrueDBGrid TDBG, C1.Win.TrueDBGrid.C1TrueDBDropdown ddown, string valueMember, string displayMember, string gridColumn = "", C1.Win.TrueDBGrid.AlignHorzEnum Alignment = C1.Win.TrueDBGrid.AlignHorzEnum.Near, bool ShowCodeColumn = false)
   {
      if (string.IsNullOrEmpty(gridColumn)) gridColumn = valueMember;
      TDBG.Columns[gridColumn].DropDown = ddown;
      TDBG.Splits[0].DisplayColumns[gridColumn].AutoDropDown = true;
      TDBG.Splits[0].DisplayColumns[gridColumn].AutoComplete = true;
      TDBG.Splits[0].DisplayColumns[gridColumn].HeadingStyle.HorizontalAlignment = Alignment;
      TDBG.Splits[0].DisplayColumns[gridColumn].Style.HorizontalAlignment = Alignment;
      TDBG.Columns[gridColumn].ValueItems.Translate = true;
      ddown.DisplayColumns[valueMember].Visible = ShowCodeColumn;
      ddown.ValueMember = valueMember;
      ddown.DisplayMember = displayMember;
      ddown.ValueTranslate = true;
   }
}